#ifndef EXTTEXT_H
#define EXTTEXT_H

#include <QWidget>
#include <QTextEdit>
#include <QString>
#include <QKeyEvent>
#include <QClipboard>
#include <QApplication>
#include <QFont>
#include <QFontMetrics>
#include <QMouseEvent>

class ExtEdit : public QTextEdit
{
    Q_OBJECT

public:
    explicit ExtEdit(QWidget *parent = NULL);
    ~ExtEdit();

    void keyPressEvent(QKeyEvent *pressed);
    void keyReleaseEvent(QKeyEvent *released);

public slots:
    void receiveText(QString stream);

signals:
    void forwardText(QString stream);
    void askSIGINT();
    void askSIGSTP();

private:

    static QString sanitize(QString &dirty);
    void shortenLog();
    static int backspaces(QString &stream);
    static int return_pos(QString &stream);

    void mousePressEvent(QMouseEvent *event);
    void mouseDoubleClickEvent(QMouseEvent *event);

    QTextEdit *innerEdit;
    QClipboard *m_clipboard;
    int m_CursorPos;
    int prevInsertedSize;
    QString m_eol;
    int m_histSize;
    int m_backscan;
};

#endif // EXTTEXT_H
