#ifndef WORKER_H
#define WORKER_H

#include <unistd.h>
#include <pty.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <poll.h>
#include <fcntl.h>

#include <iostream>
#include <string>
#include <cassert>
#include <QThread>
#include <QWidget>
#include <QString>

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::string;

#define ASSERT_IS(a, b) assert(a == b)
#define ASSERT_NOT(a, b) assert(a != b)
#define FAIL(msg) cerr << msg << endl;

enum CONSTANTS {
    BUFFER_SIZE = 100,
    POLL_TIMEOUT = 100
};


class WorkerThread : public QThread
{
    Q_OBJECT

public:
    explicit WorkerThread(QWidget *parent);
    void setHandle(int fDes);
    void setTTY(pid_t tty);

    pollfd m_pollOutput;
    int m_fDes;

signals:
    void child_sent(QString stream);

private:
    void run();
    int m_eof;
    pid_t m_TTY;
};

#endif // WORKER_H
